unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls,
  Menus, ComCtrls, gfx_files, UApoyo;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    StatusBar1: TStatusBar;
    Propiedades1: TMenuItem;
    Varios1: TMenuItem;
    FPuntuales1: TMenuItem;
    Negativo1: TMenuItem;
    Salvar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Negativo2: TMenuItem;
    
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Negativo1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure Negativo2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BMap  : TBitMap;
    M1,M2 : Mat3d;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BMap := TBitMap.Create;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin
  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute then begin
    nom := Opendialog1.FileName;
    gfx_Files.LoadAnyImageToBMP(BMap,nom,false,0,0);

    BM2Mat(BMap,M1);
    SetMat(M2,0,0,0);
    Image1.Picture.Assign(BMap) ;
  end;
end;

procedure TForm1.Salvar1Click(Sender: TObject);
var
  nom : string;
begin
  SaveDialog1.Filter := gfx_files._SaveFilterString;
  if SaveDialog1.Execute then begin
    nom := SaveDialog1.FileName;
    gfx_files.SaveBMPToAnyFile(BMap,nom,0,0);
  end;

end;

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y : Integer);
var
 pix    : integer;
 r,g, b : byte;
begin

  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  pix := Image1.Canvas.Pixels[X,Y];
  r := GetRValue (pix);
  g := GetGValue (pix);
  b := GetBValue (pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

// Negativo: z' = Lamb-z
procedure TForm1.Negativo1Click(Sender: TObject);
var
  x,y,pix  : integer;
  r,g,b    : integer;
begin
  for y := 0 to BMap.Height - 1 do
    for x := 0 to BMap.Width - 1 do begin
      pix := BMap.Canvas.Pixels[X,Y];
      r := GetRValue (pix);
      g := GetGValue (pix);
      b := GetBValue (pix);

      r := _Lamb-r;
      g := _Lamb-g;
      b := _Lamb-b;

      pix := RGB(r,g,b);
      BMap.Canvas.Pixels[X,Y] := pix;
    end;
  Image1.Picture.Assign(BMap);
end;

// Filtro de Negativo con Matrices
procedure TForm1.Negativo2Click(Sender: TObject);
var
  x,y,can,
  nx,ny     : integer;
begin
  Mat2Mat(M2,M1);
  nx := M1.nc;
  ny := M1.nr;
  SetMat(M2,nx,ny,3);

  for y := 0 to ny - 1 do
    for x := 0 to nx - 1 do
      for can := 0 to 2 do
        M2.dat[x][y][can] := _Lamb - M1.dat[x][y][can];

  Mat2BM(M2,BMap);
  Image1.Picture.Assign(BMap);
end;

end.
